 ;Protocol family
AF_UNSPEC               = 0
AF_UNIX                 = 1
AF_INET                 = 2
AF_INET6                = 10
AF_PPP                  = 777


PF_UNSPEC       = AF_UNSPEC
PF_UNIX         = AF_UNIX
PF_INET         = AF_INET
PF_INET6        = AF_INET6
PF_PPP          = AF_PPP

; Socket types
SOCK_STREAM             = 1
SOCK_DGRAM              = 2
SOCK_RAW                = 3

; Socket options
SO_ACCEPTCON            = 1 shl 0
SO_BROADCAST            = 1 shl 1
SO_DEBUG                = 1 shl 2
SO_DONTROUTE            = 1 shl 3
SO_KEEPALIVE            = 1 shl 4
SO_OOBINLINE            = 1 shl 5
SO_REUSEADDR            = 1 shl 6
SO_REUSEPORT            = 1 shl 7
SO_USELOOPBACK          = 1 shl 8
SO_BINDTODEVICE         = 1 shl 9
SO_BLOCK                = 1 shl 10

; Socket level
SOL_SOCKET              = 0

; Socket States
SS_NOFDREF              = 0x001       ; no file table ref any more
SS_ISCONNECTED          = 0x002       ; socket connected to a peer
SS_ISCONNECTING         = 0x004       ; in process of connecting to peer
SS_ISDISCONNECTING      = 0x008       ; in process of disconnecting
SS_CANTSENDMORE         = 0x010       ; can't send more data to peer
SS_CANTRCVMORE          = 0x020       ; can't receive more data from peer
SS_RCVATMARK            = 0x040       ; at mark on input
SS_ISABORTING           = 0x080       ; aborting fd references - close()
SS_RESTARTSYS           = 0x100       ; restart blocked system calls
SS_ISDISCONNECTED       = 0x800       ; socket disconnected from peer

SS_ASYNC                = 0x100       ; async i/o notify
SS_ISCONFIRMING         = 0x200       ; deciding to accept connection req
SS_MORETOCOME           = 0x400


SOCKET_MAXDATA          = 4096*32     ; must be 4096*(power of 2) where 'power of 2' is at least 8
