; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: XFT library constants and structures.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________



struct XRenderColor
  .red   dw ?
  .green dw ?
  .blue  dw ?
  .alpha dw ?
ends


XFT_MAJOR       =       2
XFT_MINOR       =       1
XFT_REVISION    =       8
XftVersion      equ     XFT_VERSION

XFT_CORE                equ     "core"
XFT_RENDER              equ     "render"
XFT_XLFD                equ     "xlfd"
XFT_MAX_GLYPH_MEMORY    equ     "maxglyphmemory"
XFT_MAX_UNREF_FONTS     equ     "maxunreffonts"


FcTypeVoid      = 0
FcTypeInteger   = 1
FcTypeDouble    = 2
FcTypeString    = 3
FcTypeBool      = 4
FcTypeMatrix    = 5
FcTypeCharSet   = 6
FcTypeFTFace    = 7
FcTypeLangSet   = 8

XftTypeVoid      =  FcTypeVoid
XftTypeInteger   =  FcTypeInteger
XftTypeDouble    =  FcTypeDouble
XftTypeString    =  FcTypeString
XftTypeBool      =  FcTypeBool
XftTypeMatrix    =  FcTypeMatrix
XftTypeCharSet   =  FcTypeCharSet
XftTypeFTFace    =  FcTypeFTFace
XftTypeLangSet   =  FcTypeLangSet

FC_SLANT_ROMAN   = 0
FC_SLANT_ITALIC  = 100
FC_SLANT_OBLIQUE = 110

XFT_SLANT_ROMAN   =  FC_SLANT_ROMAN
XFT_SLANT_ITALIC  =  FC_SLANT_ITALIC
XFT_SLANT_OBLIQUE =  FC_SLANT_OBLIQUE

FC_PROPORTIONAL         =  0
FC_DUAL                 =  90
FC_MONO                 =  100
FC_CHARCELL             =  110

XFT_PROPORTIONAL         =  FC_PROPORTIONAL
XFT_DUAL                 =  FC_DUAL
XFT_MONO                 =  FC_MONO
XFT_CHARCELL             =  FC_CHARCELL


struct   _XftFont
  .ascent                dd ?
  .descent               dd ?
  .height                dd ?
  .max_advance_width     dd ?
  .charset               dd ?
  .pattern               dd ?
ends


struct  _XftColor
  .pixel  dd ?
  .color  XRenderColor
ends


struct _XftCharSpec
  .ucs4  dd ?
  .x:    dw ?
  .y:    dw ?
ends


struct   _XftCharFontSpec
  .font  dd ?
  .ucs4  dd ?
  .x     dw ?
  .y     dw ?
ends


struct _XftGlyphSpec
  .glyph  dd ?
  .x      dw ?
  .y      dw ?
ends


struct _XftGlyphFontSpec
  .font   dd ?
  .glyph  dd ?
  .x      dw ?
  .y      dw ?
ends


struct _XGlyphInfo
  .width  dw ?
  .height dw ?
  .x      dw ?
  .y      dw ?
  .xOff   dw ?
  .yOff   dw ?
ends