; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Context is a object that represents drawing surface in FreshLib
;
;  Target OS: KolibriOS
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


cmCopy        =    0
cmInverted    =    1
cmXor         =    2


struct TKolibriContext
  .CurrentColor   dd ?
  .CurentDrawMode dd ?
ends


proc AllocateContext, .raster
begin
        push    ebx

        stdcall GetMem, sizeof.TContext
        jc      .error
        mov     ebx, eax

        mov     eax, [.raster]
        mov     [ebx+TContext.raster], eax

        stdcall GetMem, sizeof.TKolibriContext
        mov     [ebx+TContext.handle], eax
        mov     [eax+TKolibriContext.CurrentColor], 0
        mov     [eax+TKolibriContext.CurentDrawMode], cmCopy

        mov     eax, ebx
.exit:
        pop     ebx
        clc
        return

.error:
        DebugMsg 'Error allocating context.'
        xor     eax, eax
        pop     ebx
        stc
        return
endp




proc ReleaseContext, .context
begin
        push    eax
        mov     eax, [.context]
        mov     eax, [eax+TContext.handle]
        stdcall FreeMem, eax
        stdcall FreeMem, [.context]
        pop     eax
        clc
        return
endp



proc  SetDrawMode, .context, .mode
begin
        push    eax

        mov     eax, [.context]
        mov     eax, [eax+TContext.handle]

        push    [.mode]
        pop     [eax+TKolibriContext.CurentDrawMode]

        pop     eax
        return
endp




proc SetLineStyle, .context, .pLineStyle
begin
        return
endp



proc SetClipRectangle, .context, .pBounds
begin
        return
endp




