; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: TLabel object class
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: Not finished.
;_________________________________________________________________________________________
module "TLabel library"

ObjectClass Label,           \
            Window,          \
            0,               \
            0,               \
            TLabel.Get,      \
            TLabel.Set,      \
            0,               \
            TLabel.SysEventHandler


object TLabel, TWindow
  .Ftextalign dd ?

  param .TextAlign        ; text align flags.
  param .Control          ; control that to be activated
endobj



proc TLabel.Get, .obj, .paramID
begin
        mov     eax, [.obj]

        stdcall IsObject, eax, CLabel
        jc      .exit

        cmp     [.paramID], TLabel.TextAlign
        je      .gettextalign

        stc
.exit:
        return

.gettextalign:
        mov     eax, [eax+TLabel.Ftextalign]
        clc
        return
endp



proc TLabel.Set, .obj, .paramID, .value
begin
        push    eax

        mov     eax, [.obj]
        stdcall IsObject, eax, CLabel
        jc      .exit

        cmp     [.paramID], TLabel.TextAlign
        je      .settextalign

        stc
.exit:
        pop     eax
        return

.settextalign:
        push    [.value]
        pop     [eax+TLabel.Ftextalign]

.refresh:
        execute [.obj], TWindow.Refresh
        clc
        pop     eax
        return
endp



proc TLabel.SysEventHandler, .pObj, .pEvent
begin
        push    eax ebx ecx edx esi

        mov     esi, [.pObj]
        mov     ebx, [.pEvent]
        mov     eax, [ebx+TSysEvent.event]

        cmp     eax, sePaint
        je      .onpaint

.finish:
        stc
        pop     esi edx ecx ebx eax
        return

.onpaint:
  locals
   .bounds TBounds
  endl

        mov     ecx, [esi+TLabel._width]
        mov     eax, [esi+TLabel._height]
        mov     [.bounds.x], 0
        mov     [.bounds.y], 0
        mov     [.bounds.width], ecx
        mov     [.bounds.height], eax
        lea     eax, [.bounds]
        stdcall [DrawBox], [ebx+TPaintEvent.context], eax, [clDialogBk], bxNone

        stdcall Get, esi, TWindow.Caption
        test    eax, eax
        jz      .finish

        push    eax eax
        stdcall StrLen, eax
        mov     ecx, eax
        pop     eax
        lea     edx, [.bounds]
        stdcall DrawTextBox, [ebx+TPaintEvent.context], eax, edx, [esi+TLabel.Ftextalign], 0, [clDialogTxt]
        stdcall StrDel ; from the stack
        jmp     .finish
endp







endmodule