; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: comctl32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________

import_proto comctl32,  \
    AddMRUStringW, <NONE>,  'AddMRUStringW',  \
    CreateMRUListW, <NONE>,  'CreateMRUListW',  \
    CreateMappedBitmap, <.hInstance, .idBitmap, .wFlags, .lpColorMap, .ByValumMaps>,  'CreateMappedBitmap',  \
    CreatePropertySheetPage, <.lpcpropsheetpagea>,  'CreatePropertySheetPage',  \
    CreatePropertySheetPageA, <.lpcpropsheetpagea>,  'CreatePropertySheetPageA',  \
    CreatePropertySheetPageW, <.lpcpropsheetpagea>,  'CreatePropertySheetPageW',  \
    CreateStatusWindow, <.dwStyle, .lpszText, .hWndParent, .wID>,  'CreateStatusWindow',  \
    CreateStatusWindowA, <.dwStyle, .lpszText, .hWndParent, .wID>,  'CreateStatusWindowA',  \
    CreateStatusWindowW, <.dwStyle, .lpszText, .hWndParent, .wID>,  'CreateStatusWindowW',  \
    CreateToolbar, <NONE>,  'CreateToolbar',  \
    CreateToolbarEx, <.hWndParent, .dwStyle, .wID, .nBitmaps, .hBMInst, .wBMID, .lpButtons, .iNumButtons, .dxButton, .dyButton, .dxBitmap,  \
        .dyBitmap, .uStructSize>,  'CreateToolbarEx',  \
    CreateUpDownControl, <.dwStyle, .x, .y, .cx, .cy, .hParent, .nID, .hInst, .hBuddy, .nUpper, .nLower, .nPos>,  'CreateUpDownControl',  \
    DPA_Create, <NONE>,  'DPA_Create',  \
    DPA_DeleteAllPtrs, <NONE>,  'DPA_DeleteAllPtrs',  \
    DPA_DeletePtr, <NONE>,  'DPA_DeletePtr',  \
    DPA_Destroy, <NONE>,  'DPA_Destroy',  \
    DPA_DestroyCallback, <NONE>,  'DPA_DestroyCallback',  \
    DPA_EnumCallback, <NONE>,  'DPA_EnumCallback',  \
    DPA_GetPtr, <NONE>,  'DPA_GetPtr',  \
    DPA_InsertPtr, <NONE>,  'DPA_InsertPtr',  \
    DPA_Search, <NONE>,  'DPA_Search',  \
    DPA_SetPtr, <NONE>,  'DPA_SetPtr',  \
    DPA_Sort, <NONE>,  'DPA_Sort',  \
    DSA_Create, <NONE>,  'DSA_Create',  \
    DSA_DeleteAllItems, <NONE>,  'DSA_DeleteAllItems',  \
    DSA_Destroy, <NONE>,  'DSA_Destroy',  \
    DSA_DestroyCallback, <NONE>,  'DSA_DestroyCallback',  \
    DSA_GetItemPtr, <NONE>,  'DSA_GetItemPtr',  \
    DSA_InsertItem, <NONE>,  'DSA_InsertItem',  \
    DefSubclassProc, <NONE>,  'DefSubclassProc',  \
    DestroyPropertySheetPage, <.hpropsheetpage>,  'DestroyPropertySheetPage',  \
    DrawInsert, <.handParent, .hLB, .nItem>,  'DrawInsert',  \
    DrawStatusText, <.hDC, .lprc, .pszText, .uFlags>,  'DrawStatusText',  \
    DrawStatusTextA, <.hDC, .lprc, .pszText, .uFlags>,  'DrawStatusTextA',  \
    DrawStatusTextW, <.hDC, .lprc, .pszText, .uFlags>,  'DrawStatusTextW',  \
    EnumMRUListW, <NONE>,  'EnumMRUListW',  \
    FlatSB_EnableScrollBar, <.hwnd, .ByValt, .uint>,  'FlatSB_EnableScrollBar',  \
    FlatSB_GetScrollInfo, <.hwnd, .code, .lpscrollinfo>,  'FlatSB_GetScrollInfo',  \
    FlatSB_GetScrollPos, <.hwnd, .code>,  'FlatSB_GetScrollPos',  \
    FlatSB_GetScrollProp, <.hwnd, .propIndex, .lpint>,  'FlatSB_GetScrollProp',  \
    FlatSB_GetScrollRange, <.hwnd, .code, .lpint>,  'FlatSB_GetScrollRange',  \
    FlatSB_SetScrollInfo, <.hwnd, .code, .lpscrollinfo, .fRedraw>,  'FlatSB_SetScrollInfo',  \
    FlatSB_SetScrollPos, <.hwnd, .code, .pos, .fRedraw>,  'FlatSB_SetScrollPos',  \
    FlatSB_SetScrollProp, <.hwnd, .index, .newValue, .bool>,  'FlatSB_SetScrollProp',  \
    FlatSB_SetScrollRange, <.hwnd, .code, .min, .max, .fRedraw>,  'FlatSB_SetScrollRange',  \
    FlatSB_ShowScrollBar, <.hwnd, .code, .bool>,  'FlatSB_ShowScrollBar',  \
    FreeMRUList, <NONE>,  'FreeMRUList',  \
    GetEffectiveClientRect, <.hWnd, .lprc, .lpInfo>,  'GetEffectiveClientRect',  \
    GetMUILanguage, <VOID>,  'GetMUILanguage',  \
    ImageList_Add, <.himl, .hbmImage, .hbmMask>,  'ImageList_Add',  \
    ImageList_AddIcon, <NONE>,  'ImageList_AddIcon',  \
    ImageList_AddMasked, <.himl, .hbmImage, .crMask>,  'ImageList_AddMasked',  \
    ImageList_BeginDrag, <.himlTrack, .iTrack, .dxHotspot, .dyHotspot>,  'ImageList_BeginDrag',  \
    ImageList_Copy, <.himlDst, .iDst, .himlSrc, .iSrc, .uFlags>,  'ImageList_Copy',  \
    ImageList_Create, <.cx, .cy, .flags, .cInitial, .cGrow>,  'ImageList_Create',  \
    ImageList_Destroy, <.himl>,  'ImageList_Destroy',  \
    ImageList_DragEnter, <.hwndLock, .x, .y>,  'ImageList_DragEnter',  \
    ImageList_DragLeave, <.hWndOwner>,  'ImageList_DragLeave',  \
    ImageList_DragMove, <.x, .y>,  'ImageList_DragMove',  \
    ImageList_DragShowNolock, <.fBoolean>,  'ImageList_DragShowNolock',  \
    ImageList_Draw, <.himl, .i, .hdcDst, .x, .y, .fStyle>,  'ImageList_Draw',  \
    ImageList_DrawEx, <.himl, .i, .hdcDst, .x, .y, .dx, .dy, .rgbBk, .rgbFg, .fStyle>,  'ImageList_DrawEx',  \
    ImageList_DrawIndirect, <.pimldp>,  'ImageList_DrawIndirect',  \
    ImageList_Duplicate, <.himl>,  'ImageList_Duplicate',  \
    ImageList_EndDrag, <VOID>,  'ImageList_EndDrag',  \
    ImageList_GetBkColor, <.himl>,  'ImageList_GetBkColor',  \
    ImageList_GetDragImage, <.ppt, .pptHotspot>,  'ImageList_GetDragImage',  \
    ImageList_GetFlags, <NONE>,  'ImageList_GetFlags',  \
    ImageList_GetIcon, <.himl, .i, .flags>,  'ImageList_GetIcon',  \
    ImageList_GetIconSize, <.himl, .cx, .cy>,  'ImageList_GetIconSize',  \
    ImageList_GetImageCount, <.himl>,  'ImageList_GetImageCount',  \
    ImageList_GetImageInfo, <.himl, .i, .pImageInfo>,  'ImageList_GetImageInfo',  \
    ImageList_GetImageRect, <NONE>,  'ImageList_GetImageRect',  \
    ImageList_LoadImage, <.hInst, .lpszbmp, .cx, .cGrow, .crMask, .uType, .uFlags>,  'ImageList_LoadImage',  \
    ImageList_LoadImageA, <.hInst, .lpszbmp, .cx, .cGrow, .crMask, .uType, .uFlags>,  'ImageList_LoadImageA',  \
    ImageList_LoadImageW, <.hInst, .lpszbmp, .cx, .cGrow, .crMask, .uType, .uFlags>,  'ImageList_LoadImageW',  \
    ImageList_Merge, <.himl1, .i1, .himl2, .i2, .dx, .dy>,  'ImageList_Merge',  \
    ImageList_Read, <.pstm>,  'ImageList_Read',  \
    ImageList_Remove, <.himl, .i>,  'ImageList_Remove',  \
    ImageList_Replace, <.himl, .i, .hbmImage, .hbmMask>,  'ImageList_Replace',  \
    ImageList_ReplaceIcon, <.himl, .i, .hicon>,  'ImageList_ReplaceIcon',  \
    ImageList_SetBkColor, <.himl, .clrBk>,  'ImageList_SetBkColor',  \
    ImageList_SetDragCursorImage, <.himlDrag, .iDrag, .dxHotspot, .dyHotspot>,  'ImageList_SetDragCursorImage',  \
    ImageList_SetFilter, <NONE>,  'ImageList_SetFilter',  \
    ImageList_SetFlags, <NONE>,  'ImageList_SetFlags',  \
    ImageList_SetIconSize, <.himl, .cx, .cy>,  'ImageList_SetIconSize',  \
    ImageList_SetImageCount, <.himl, .uNewCount>,  'ImageList_SetImageCount',  \
    ImageList_SetOverlayImage, <.himl, .iImage, .iOverlay>,  'ImageList_SetOverlayImage',  \
    ImageList_Write, <.himl, .pstm>,  'ImageList_Write',  \
    InitCommonControls, <VOID>,  'InitCommonControls',  \
    InitCommonControlsEx, <.pIcce>,  'InitCommonControlsEx',  \
    InitMUILanguage, <.uiLang>,  'InitMUILanguage',  \
    InitializeFlatSB, <.hwnd>,  'InitializeFlatSB',  \
    LBItemFromPt, <.hLB, .pt, .bAutoScroll>,  'LBItemFromPt',  \
    MakeDragList, <.hLB>,  'MakeDragList',  \
    MenuHelp, <.uMsg, .wParam, .lParam, .hMainMenu, .hInst, .hwndStatus, .lpwIDs>,  'MenuHelp',  \
    PropertySheet, <.lpcpropsheetheadera>,  'PropertySheet',  \
    PropertySheetA, <.lpcpropsheetheadera>,  'PropertySheetA',  \
    PropertySheetW, <.lpcpropsheetheadera>,  'PropertySheetW',  \
    RemoveWindowSubclass, <NONE>,  'RemoveWindowSubclass',  \
    SetWindowSubclass, <NONE>,  'SetWindowSubclass',  \
    ShowHideMenuCtl, <.hWnd, .uFlags, .lpInfo>,  'ShowHideMenuCtl',  \
    Str_SetPtrW, <NONE>,  'Str_SetPtrW',  \
    UninitializeFlatSB, <.hwnd>,  'UninitializeFlatSB',  \
    _TrackMouseEvent, <NONE>,  '_TrackMouseEvent'
