; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Executable file formating macro library.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________

TargetOS equ Linux

macro @BinaryType type {
  if type eq GUI
    format ELF executable 3
    entry start
  end if

  if type eq console
    format ELF executable 3
    entry start
  end if

  if type eq DLL
    format ELF executable  ; is it correct???
  end if

  segment readable writeable executable
}


macro @AllDataSection {
segment readable writeable
IncludeAllGlobals
}

macro @AllDataEmbeded {
IncludeAllGlobals
}

macro __create_all_imports {


if __TotalImports > 0
  segment interpreter readable
end if

__importdata:

if __TotalImports > 0
  rept DynamicLibList@count i:1 \{
    match name:filename, DynamicLibList\#i \\{
      \\include filename
    \\}
  \}

  interpreter '/lib/ld-linux.so.2'
end if

__imports:
  __ImportAll

  __TotalImports = $ - __imports
  DispSize 'ELF Import data:', $ - __importdata
}


macro @AllImportSection {
  __create_all_imports
}


macro @AllImportEmbeded {
  __create_all_imports
}

