; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Clipboard management library.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


if used ClipboardRead | used ClipboardWrite
  __UseClipboard = 1
else
  __UseClipboard = 0
end if



proc ClipboardRead
.result dd ?

.event XEvent

.return_type    dd ?
.return_format  dd ?
.return_items   dd ?
.return_remains dd ?
.return_data    dd ?

begin
        pushad
        mov     [.result], 0

        cinvoke XGetSelectionOwner, [hApplicationDisplay], [atomSelClipboard]
        test    eax, eax
        jz      .finish

        cinvoke XConvertSelection, [hApplicationDisplay], [atomSelClipboard], [atomUTF8], [atomUTF8], [hClipboardWindow], CurrentTime

.wait_loop:
        lea     eax, [.event]
        cinvoke XCheckTypedEvent, [hApplicationDisplay], SelectionNotify, eax
        test    eax, eax
        jz      .wait_loop

        cmp     [.event+XSelectionEvent.property], None
        je      .finish

        lea     eax, [.return_data]
        lea     ecx, [.return_remains]
        lea     edx, [.return_items]

        push    eax
        push    ecx
        push    edx

        lea     eax, [.return_format]
        lea     ecx, [.return_type]
        push    eax
        push    ecx

        push    AnyPropertyType
        push    FALSE
        push    $7fffffff
        push    0
        push    [.event+XSelectionEvent.property]
        push    [.event+XSelectionEvent.requestor]
        push    [hApplicationDisplay]
        call    [XGetWindowProperty]
        add     esp, 12*4

        mov     eax, [.return_type]
        cmp     eax, [atomUTF8]
        jne     .finish

        mov      eax, [.return_data]
        test     eax, eax
        jz       .finish

        stdcall StrDup, eax
        mov     [.result], eax

        cinvoke XFree, [.return_data]

.finish:
        popad
        mov     eax, [.result]
        return
endp



proc ClipboardWrite, .hstring
begin



        return
endp




uglobal
  var atomSelClipboard = 0
  var atomUTF8 = 0
  var hClipboardWindow = 0
endg

cAtomClipboard text 'CLIPBOARD'
cAtomUTF8 text 'UTF8_STRING'


proc __InitLinuxClipboard
begin
        cinvoke XInternAtom, [hApplicationDisplay], cAtomClipboard, FALSE
        mov     [atomSelClipboard], eax

        cinvoke XInternAtom, [hApplicationDisplay], cAtomUTF8, FALSE
        mov     [atomUTF8], eax

        cinvoke XCreateWindow, [hApplicationDisplay], [hRootWindow], 0, 0, 1, 1, 0, CopyFromParent, InputOnly, CopyFromParent, 0, 0
        mov     [hClipboardWindow], eax
        return
endp

