;<ff
Window frmBrowser, 3, 0, 'TForm', 'Labels explorer', $60D0000, $10080, 0, 600, 224, 640, 480, frmBrowserWinProc;
Window NONE, 0, 5, 'SysTreeView32', 'TreeView', $50000037, $200, 2, 0, 42, 632, 414, 0;
Window NONE, 3, 3, 'BUTTON', 'Filter', $54002007, $20, 3, 0, 0, 632, 42, GroupboxProc;
Window NONE, 0, 0, 'BUTTON', 'Structures', $50000009, $20, 101, 64, 16, 72, 17, 0;
Window NONE, 0, 0, 'BUTTON', 'Data', $50000009, $20, 102, 136, 16, 48, 17, 0;
Window NONE, 0, 0, 'BUTTON', 'Show all', $50000009, $20, 104, 256, 16, 64, 17, 0;
Window NONE, 0, 0, 'BUTTON', 'Labels', $50000009, $20, 100, 8, 16, 56, 17, 0;
Window NONE, 2, 0, 'BUTTON', 'Constants', $50000009, $20, 103, 184, 16, 72, 17, 0;
;ff>
cExplorerRoot text 'Root'

uglobal
  hLabelExplorer dd ?
endg


proc OnExplorer, .wparam, .lparam
.rect RECT
begin
        cmp     [hLabelExplorer], 0
        je      .oldwin_ok

        invoke  SendMessageA, [hLabelExplorer], WM_CLOSE, 0, 0
        mov     [hLabelExplorer], 0

.oldwin_ok:
        cmp     [ptrLabels], 0
        je      .missing_info

        lea     eax, [.rect]
        invoke  GetWindowRect, [hEditorsHost], eax

        sub     [.rect.right], 680
        add     [.rect.top], 32

        stdcall CreateForm, frmBrowser, [hEditorsHost]
        mov     [hLabelExplorer], ebx

        invoke  SetWindowPos, ebx, 0, [.rect.right], [.rect.top], 0, 0, SWP_NOSIZE or SWP_NOZORDER or SWP_SHOWWINDOW

.finish:
        return

.missing_info:
        invoke  MessageBoxA, [hEditorsHost], cErrorNotCompiled, 0, MB_OK or MB_ICONINFORMATION
        jmp     .finish
endp

iglobal
  cErrorNotCompiled text 'You must compile the source in order to use cross reference functions.'
  cErrorNotDefined  text 'This symbol is not defined. Try to compile without errors.'
endg



proc AddLabelsToTree, .tree, .parent, .ptrVarArray, .filterProc
.tvi  TVINSERTSTRUCT
begin
        push    esi ebx

        mov     eax, [.ptrVarArray]
        mov     esi, [eax]              ; pointer to TArray
        test    esi, esi
        jz      .finish

        mov     ebx, [esi+TArray.count]
        lea     esi, [esi+TArray.array]

.iteratelist:
;        cmp     [esi+TLabel.Children], 0        ; because some of the childrens
;        jne     .addit

        cmp     [.filterProc], 0
        je      .addit

        call    [.filterProc]
        jnc     .next

.addit:
        mov     eax, [.parent]
        mov     [.tvi.hParent], eax
        mov     ecx, TVI_LAST
        cmp     eax, TVI_ROOT
        jne     @f
        mov     ecx, TVI_SORT
@@:
        mov     [.tvi.hInsertAfter], ecx
        mov     [.tvi.item.mask], TVIF_TEXT or TVIF_PARAM

        mov     eax, [esi+TLabel.iName]
        add     eax, [ptrNames]
        mov     [.tvi.item.pszText], eax
        mov     [.tvi.item.lParam], esi

        lea     eax, [.tvi]
        invoke  SendMessageA, [.tree], TVM_INSERTITEM, 0, eax

        cmp     dword [esi], 0
        je      .next
        stdcall AddLabelsToTree, [.tree], eax, esi, 0

.next:
        add     esi, sizeof.TLabel
        dec     ebx
        jnz     .iteratelist

.finish:
        pop     ebx esi
        return
endp




;**************************************************************************
; frmBrowser message handling procedure.
;
;   hwnd - handle of the form window
;   wmsg     - message code
;   wparam, lparam - parameters of the message
;**************************************************************************
proc frmBrowserWinProc, .hwnd, .wmsg, .wparam, .lparam
begin
        mov     ebx, [.wmsg]
        call    JumpTo
        MessageList                                             \
        FM_AFTERCREATE, .fmaftercreate,                         \
        WM_NOTIFY,      .wmnotify,                              \
        WM_CLOSE,       .wmclose

.default:
        stc
        return

.wmclose:
        invoke  DestroyWindow, [.hwnd]
        clc
        return

.fmaftercreate:
        stdcall CreateForm, frmLabelProp, [.hwnd]
        stdcall SetAlign, ebx, waRight
        invoke  SetWindowLongA, ebx, GWL_ID, idLabelProp

        invoke  CreateWindowExA, 0, cSplitterClassName, NULL,            \
                WS_CLIPSIBLINGS or WS_CHILD,              \
                0, 0, 0, 0, [.hwnd], NULL, [hInstance], ebx
        push    eax
        invoke  SendMessageA, eax, SPM_SETCURSORS, resVSplit, resHSplit
        pop     eax
        invoke  SendMessageA, eax, SPM_SETMAXMIN, 20, 10000

        invoke  GetDlgItem, [.hwnd], 1   ; static panel
        invoke  GetDlgItem, eax, 3      ; group box
        mov     ebx, eax
        invoke  SendDlgItemMessageA, ebx, 100, BM_SETCHECK, 1, 0
        invoke  SendMessageA, ebx, WM_COMMAND, 100, 0

        invoke  SetFocus, ebx

        clc
        return

.wmnotify:
        mov     esi, [.lparam]
        cmp     [esi+NMHDR.code], TVN_SELCHANGED
        je      .selchanged

        jmp     .default

; selection of the treeview changed.
.selchanged:
; Pointer to TLabel structure of given label.
        invoke  GetDlgItem, [.hwnd], 1
        mov     ebx, eax

        mov     edi, [esi+NMTREEVIEW.itemNew.lParam]
        test    edi, edi
        jz      .finish

        invoke  SendDlgItemMessageA, [.hwnd], idLabelProp, LPR_DISPLAY, 0, edi

.finish:
        clc
        return
endp






proc GroupboxProc, .hwnd, .wmsg, .wparam, .lparam
begin
        cmp     [.wmsg], WM_COMMAND
        je      .wmcommand
.default:
        stc
        return

.wmcommand:
        movzx   eax, word [.wparam]
        cmp     eax, 100
        jl      .default
        cmp     eax, 104
        jg      .default

.update:
; Update tree-view control
        push    eax

        invoke  GetParent, [.hwnd]
        invoke  GetDlgItem, eax, 2
        mov     edi, eax
        invoke  LockWindowUpdate, edi
        invoke  SendMessageA, edi, TVM_DELETEITEM, 0, TVI_ROOT

        pop     eax

        mov     edx, procCheckForLabel
        cmp     eax, 100
        je      .filterok

        mov     edx, procCheckForStruct
        cmp     eax, 101
        je      .filterok

        mov     edx, procCheckForData
        cmp     eax, 102
        je      .filterok

        mov     edx, procCheckForConst
        cmp     eax, 103
        je      .filterok

        xor     edx, edx

.filterok:
        stdcall AddLabelsToTree, edi, TVI_ROOT, ptrLabels, edx
        invoke  LockWindowUpdate, NULL
        clc
        return
endp





;------------------------------------------------
; FILTER PROCEDURES
;------------------------------------------------

proc procCheckForLabel
begin
        test    [esi+TLabel.flags], lfCanRedefine
        jnz     .no

        test    [esi+TLabel.flags], lfOptimized
        jz      .no

        cmp     [esi+TLabel.DataSize], 0
        jne     .no

        stc
        return
.no:    clc
        return
endp


proc procCheckForStruct
begin
        cmp     [esi+TLabel.ValueLo], 0
        jne     .no
        cmp     [esi+TLabel.ValueHi], 0
        jne     .no

        test    [esi+TLabel.flags], lfOptimized
        jnz      .no

        test    [esi+TLabel.flags], lfDefined
        jz      .no

        test    [esi+TLabel.flags], lfCanRedefine
        jnz     .no

        cmp     [esi+TLabel.DataSize], 0
        jne     .no

        stc
        return
.no:    clc
        return
endp



proc procCheckForData
begin
        cmp     [esi+TLabel.DataSize], 0
        je      .no
        stc
        return

.no:    clc
        return
endp



proc procCheckForConst
begin
        test    [esi+TLabel.flags], lfCanRedefine
        jz      .no
        stc
        return
.no:    clc
        return
endp



