proc LastError
begin
        pushad
        invoke  GetLastError
        stdcall ErrorMessage, eax
        popad
        return
endp

;-------------------------------------------------------------------------
; Shows message box with error message.
; Arguments:
;  errorcode - code of the error. This is code returned by GetLastError.
;
;  Because of missing information about "Message table" resources, this
;  procedure uses specific processing for application defined messages
;-------------------------------------------------------------------------
proc ErrorMessage, .errorcode
.errstr dd ?
begin
        pushad

        test    [.errorcode], errFresh
        jnz     .freshmsg

        lea     esi, [.errstr]
        invoke  FormatMessageA, FORMAT_MESSAGE_ALLOCATE_BUFFER or                \
                               FORMAT_MESSAGE_FROM_SYSTEM,                      \
                               NULL, [.errorcode], NULL, esi, 256, NULL
        invoke  MessageBoxA, [hApplication], [.errstr], NULL, MB_OK or MB_ICONERROR
        invoke  LocalFree, [.errstr]
.finish:
        popad
        return

.freshmsg:
        cmp     [.errorcode], errCanceled
        je      .finish

        mov     esi, FreshErrorMessages-8

; search for message
.loop:
        add     esi, 8
        mov     ecx, [esi]
        mov     eax, [esi+4]
        jecxz   .notfound

        cmp     eax, [.errorcode]
        jne     .loop

;found:
.msg:
        invoke  MessageBoxA, [hApplication], ecx, NULL, MB_OK or MB_ICONERROR
        popad
        return

.notfound:
        mov     ecx, errmsgUnknownError
        jmp     .msg

endp



